/**
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.kilim.repository;

import java.io.InputStream;

import junit.framework.TestCase;

/**
 * ClassLoader implementation of ResourceLoader unit testing
 * @author dutoo
 */
public class ClassLoaderResourceLoaderTest extends TestCase {

   /**
    * Constructor for ClassLoaderResourceLoaderTest.
    * @param arg0 name
    */
   public ClassLoaderResourceLoaderTest(String arg0) {
      super(arg0);
   }

   /**
    * tries to find a non existing Resource
    * @throws ResourceNotFoundException should not happen
    */
   public void testLoadingException() throws ResourceNotFoundException {
      ClassLoader classLoader = getClass().getClassLoader();
      ResourceLoader resLoader = new ClassLoaderResourceLoader(classLoader);
      
      try {
         InputStream is = resLoader.getResource("plouf.xml");  
         fail("ResourceLoaderClassLoader should throw ResourceNotFoundException");
      } catch (ResourceNotFoundException rnfex) {
         assertTrue(rnfex.getResourceName().equals("plouf.xml"));
      }
   }

}
