package org.objectweb.kilim.description;

import java.util.Iterator;

import org.objectweb.kilim.KilimException;

/**
 * @author horn
 * This is the parent interface for all interfaces and classes corresponding to template elements
 */
public interface TemplateElement extends Cloneable {
	
	/**
	 * returns the template in which the element is defined.
	 * @return Template
	 */
	TemplateDescription getContainingTemplate();
	
	/**
	 * sets the template in which the element is defined.
	 * @param aTemplate : the template.
	 * @throws KilimException :
	 */
	void setContainingTemplate(TemplateDescription aTemplate) throws KilimException;
	
	/**
	 * clones a template
	 * @return Object
	 */
	Object clone();
	
	/**
	 * returns as an iterator all templates in which an element has been defined and overloaded.
	 * @return Iterator
	 */
	Iterator getTemplateDefHierarchy();
}
