/**
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.kilim.model;

import org.objectweb.kilim.KilimException;

/**
 * @author horn
 */

public interface ComponentProperty extends ComponentInterface {		
	/**
	 * sets the value of a property.
	 * @param aValue : the value to be assigned to the property.
	 * @throws KilimException : generated when aValue is illegal (in case of type mismatch, for example).
	 */
	void setValue(Object aValue) throws KilimException;
}		
