/**
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.kilim.model.instanciation;

import org.objectweb.kilim.KilimException;
import org.objectweb.kilim.model.Component;
import org.objectweb.kilim.model.ComponentInterface;
import org.objectweb.kilim.model.ComponentSlot;
import org.objectweb.kilim.model.mapping.MappingContext;
/**
 * @author horn
 */
	
public class NullInstanciationMger extends InstanciationMger {
	
	/**
	 * @see org.objectweb.kilim.model.InstanciationMger#initializeInstanciation(TemplateDescription)
	 */
	public void initializeInstanciation(Component aComponent, ComponentInterface aInterface, MappingContext aContext) throws KilimException { }
	
	/**
	 * @see org.objectweb.kilim.model.InstanciationMger#finalizeInstanciation(Component)
	 */
	public void finalizeInstanciation(Component aComponent, ComponentInterface aInterface, MappingContext aContext) throws KilimException  { }
	
	/**
	 * @see org.objectweb.kilim.model.services.InstanciationMger#prePlug(Component, ComponentSlot, MappingContext)
	 */
	public void initializePlug(Component aComponent, ComponentSlot aSlot, MappingContext aContext) throws KilimException  { }
	
	/**
	 * @see org.objectweb.kilim.model.services.InstanciationMger#postPlug(Component, ComponentSlot, MappingContext)
	 */
	public void finalizePlug(Component aComponent, ComponentSlot aSlot, MappingContext aContext) throws KilimException  { }
}
