/**
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.objectweb.kilim.model.mapping;

import java.util.Stack;

/**
 * This empty interface is the parent interface for specific contexts to be used in getValue()
 * and execute() methods of RuntimeAction and RuntimeSource interfaces.
 * @author horn
 */	
public interface MappingContext {			
	/**
	 * Method getContextStack.
	 * @return Stack
	 */
	Stack getContextStack();
	
	/**
	 * Method getCallStack.
	 * @return Stack
	 */
	Stack getCallStack();
}
