package org.objectweb.kilim.tools;

import java.util.Iterator;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import org.objectweb.kilim.model.Component;
import org.objectweb.kilim.model.ComponentSlot;

/**
 * @author delpiano
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class KilimComponentTreeModel implements TreeModel {

	private Component component;

	/**
	 * Method KilimComponentTreeModel.
	 * @param cmpnnt :
	 */
	public KilimComponentTreeModel(Component cmpnnt) {
		super();
		component = cmpnnt;
	}

	/**
	 * @see javax.swing.tree.TreeModel#getRoot()
	 */
	public Object getRoot() {
		return component;
	}

	/**
	 * @see javax.swing.tree.TreeModel#getChild(Object, int)
	 */
	public Object getChild(Object parent, int index) {
		
		if (parent instanceof Component) {

			Component cmpnnt = (Component) parent;
			Iterator intfcs = cmpnnt.getInterfaces();
			Iterator sbcmpnnts = cmpnnt.getSubComponents();
			Iterator slts = cmpnnt.getSlots();
			int crt_indx = 0;
			for (; intfcs.hasNext(); crt_indx++) {
				Object nxt = intfcs.next();
				if (crt_indx == index) {
					return nxt;
				}
			}
			for (; sbcmpnnts.hasNext(); crt_indx++) {
				Object nxt = sbcmpnnts.next();
				if (crt_indx == index) {
					return nxt;
				}
			}
			for (; slts.hasNext(); crt_indx++) {
				Object nxt = slts.next();
				if (crt_indx == index) {
					return nxt;
				}
			}
			return null;
			
		} else if (parent instanceof ComponentSlot) {
			ComponentSlot slt = (ComponentSlot) parent;
			int crt_indx = 0;
			Iterator plgs = slt.getPlugIns();
			for (; plgs.hasNext(); crt_indx++) {
				Object nxt = plgs.next();
				if (crt_indx == index) {
					return nxt;
				}
			}
			
		}
		
		return null;
	}

	/**
	 * @see javax.swing.tree.TreeModel#getChildCount(Object)
	 */
	public int getChildCount(Object parent) {
		
		if (parent instanceof Component) {

			Component cmpnnt = (Component) parent;
			Iterator intfcs = cmpnnt.getInterfaces();
			Iterator sbcmpnnts = cmpnnt.getSubComponents();
			Iterator slts = cmpnnt.getSlots();
			int crt_indx = 0;
			for (; intfcs.hasNext(); crt_indx++) {
				intfcs.next();
			}
			for (; sbcmpnnts.hasNext(); crt_indx++) {
				sbcmpnnts.next();
			}
			for (; slts.hasNext(); crt_indx++) {
				slts.next();
			}
			return crt_indx;
		
		} else if (parent instanceof ComponentSlot) {
			
			Iterator plgs = ((ComponentSlot) parent).getPlugIns();
			int crt_indx = 0;
			for (; plgs.hasNext(); crt_indx++) {
				plgs.next();
			}
			return crt_indx;
			
		}
		
		return 0;
	}

	/**
	 * @see javax.swing.tree.TreeModel#isLeaf(Object)
	 */
	public boolean isLeaf(Object node) {
		return (getChildCount(node) == 0);
	}

	/**
	 * @see javax.swing.tree.TreeModel#valueForPathChanged(TreePath, Object)
	 */
	public void valueForPathChanged(TreePath path, Object newValue) {
	}

	/**
	 * @see javax.swing.tree.TreeModel#getIndexOfChild(Object, Object)
	 */
	public int getIndexOfChild(Object parent, Object child) {
		if (parent instanceof Component) {

			Component cmpnnt = (Component) parent;
			Iterator intfcs = cmpnnt.getInterfaces();
			Iterator sbcmpnnts = cmpnnt.getSubComponents();
			Iterator slts = cmpnnt.getSlots();
			int crt_indx = 0;
			for (; intfcs.hasNext(); crt_indx++) {
				Object nxt = intfcs.next();
				if (nxt == child) {
					return crt_indx;
				}
			}
			for (; sbcmpnnts.hasNext(); crt_indx++) {
				Object nxt = sbcmpnnts.next();
				if (nxt == child) {
					return crt_indx;
				}
			}
			for (; slts.hasNext(); crt_indx++) {
				Object nxt = slts.next();
				if (nxt == child) {
					return crt_indx;
				}
			}
			return -1;
			
		} else if (parent instanceof ComponentSlot) {
			
			ComponentSlot slt = (ComponentSlot) parent;
			Iterator plgs = slt.getPlugIns();
			int crt_indx = 0;
			for (; plgs.hasNext(); crt_indx++) {
				Object nxt = plgs.next();
				if (nxt == child) {
					return crt_indx;
				}
			}	
		}
		return -1;
	}

	/**
	 * @see javax.swing.tree.TreeModel#addTreeModelListener(TreeModelListener)
	 */
	public void addTreeModelListener(TreeModelListener l) {
	}

	/**
	 * @see javax.swing.tree.TreeModel#removeTreeModelListener(TreeModelListener)
	 */
	public void removeTreeModelListener(TreeModelListener l) {
	}

}
